=== modified file 'NEWS'
--- NEWS	2008-05-21 15:45:23 +0000
+++ NEWS	2008-05-22 07:20:06 +0000
@@ -62,6 +62,10 @@
       them.
       (Vincent Ladeuil, #229076)
 
+    * Treat an encoding of '' as ascii; this can happen when bzr is run
+      under vim on Mac OS X.
+      (Neil Martinsen-Burrell)
+
   DOCUMENTATION:
 
     * Added directory structure and started translation of docs in spanish.

=== modified file 'bzrlib/osutils.py'
--- bzrlib/osutils.py	2008-05-08 04:33:38 +0000
+++ bzrlib/osutils.py	2008-05-21 08:31:00 +0000
@@ -1344,7 +1344,9 @@
     # Windows returns 'cp0' to indicate there is no code page. So we'll just
     # treat that as ASCII, and not support printing unicode characters to the
     # console.
-    if user_encoding in (None, 'cp0'):
+    #
+    # For python scripts run under vim, we get '', so also treat that as ASCII
+    if user_encoding in (None, 'cp0', ''):
         user_encoding = 'ascii'
     else:
         # check encoding

=== modified file 'bzrlib/tests/test_osutils_encodings.py'
--- bzrlib/tests/test_osutils_encodings.py	2007-11-01 09:52:45 +0000
+++ bzrlib/tests/test_osutils_encodings.py	2008-05-05 17:02:02 +0000
@@ -197,6 +197,15 @@
                           ' Continuing with ascii encoding.\n',
                           sys.stderr.getvalue())
 
+    def test_user_empty(self):
+        """Running bzr from a vim script gives '' for a preferred locale"""
+        def f():
+            return ''
+
+        locale.getpreferredencoding = f
+        self.assertEquals('ascii', osutils.get_user_encoding(use_cache=False))
+        self.assertEquals('', sys.stderr.getvalue())
+
     def test_user_locale_error(self):
         def f():
             raise locale.Error, 'unsupported locale'

